Unit DE40R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE35R_p, DE42RP_p, DE28RS_p, UTDE12_p;

procedure DE40R(F :Proc_F70; M :Integer; var JSTART :Integer;
                var YX :Array of Real; var X :Real;
                var DY :Array of Real; H :Real;
                var DELTY :Array of Real; var DF :Array of Real;
                var RFN :Array of Real; var RF :Array of Real;
                var YP :Array of Real; var DYP :Array of Real;
                var IERR :Integer);

implementation

procedure DE40R(F :Proc_F70; M :Integer; var JSTART :Integer;
                var YX :Array of Real; var X :Real;
                var DY :Array of Real; H :Real;
                var DELTY :Array of Real; var DF :Array of Real;
                var RFN :Array of Real; var RF :Array of Real;
                var YP :Array of Real; var DYP :Array of Real;
                var IERR :Integer);
var
I,K,K1 :Integer;
ALP,RH :Real;
BUL2 :Boolean;
const
C1 :Real = 12.0;
C2 :Real = 0.08333333333333333;
C4 :Real = -0.05;
IMAX :Integer = 6;
P :Real = 0.01;
EPS :Real = 1.0E-7;
IORDER :Integer = 5;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16;
begin
if ( JSTART >= 0 )
 then goto _4;
if ( IERR = 0 )
 then goto _1;
IERR := 0;
goto _6;
_1:
for K:=1 to 4 do
 begin
  K1 := K+1;
  for I:=1 to M do
   begin
    DF[(I-1)+(K-1)*M] := DF[(I-1)+(K-1)*M]-DF[(I-1)+(K1-1)*M];
_2:
   end;
 end;
for I:=1 to M do
 begin
  DY[I-1] := DYP[I-1];
_3:
 end;
goto _6;
_4:
_COM40R.elm2 := X;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
  DYP[I-1] := DY[I-1];
_5:
 end;
IERR := 0;
if ( JSTART <> 0 )
 then goto _6;
F(X,YX,RF,M);
DE35R(F,M,IORDER,_COM40R.elm2,YP,DYP,H,X,YX,DY,DF,RFN,RF,DELTY);
goto _16;
_6:
if ( H = _COM40R.elm1 ) 
 then goto _7;
ALP := H/_COM40R.elm1;
DE42RP(M,IORDER,ALP,DF,DY);
_7:
for I:=1 to M do
 begin
  RF[I-1] := DF[(I-1)+2*M]+DF[(I-1)+3*M];
  YX[I-1] := YP[I-1]+DY[I-1]+C1*DF[(I-1)+0*M]+RF[I-1];
  RF[I-1] := RF[I-1]+DF[(I-1)+0*M]+DF[(I-1)+1*M];
_8:
 end;
RH := C2*IntPower(H,2);
X := _COM40R.elm2+H;
for K:=1 to IMAX do
 begin
  BUL2 := True;
  for I:=1 to M do
   begin
    DELTY[I-1] := -RF[I-1];
_9:
   end;
  F(X,YX,RF,M);
  for I:=1 to M do
   begin
    RF[I-1] := RF[I-1]*RH;
    DELTY[I-1] := DELTY[I-1]+RF[I-1];
    YX[I-1] := DELTY[I-1]+YX[I-1];
    if ( Abs(YX[I-1]) <= P )
     then goto _10;
    DELTY[I-1] := DELTY[I-1]/YX[I-1];
_10:
    if ( Abs(DELTY[I-1]) > EPS )
     then BUL2 := False;
_11:
   end;
  if ( BUL2 ) 
   then goto _14;
_12:
 end;
IERR := 65;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_13:
 end;
X := _COM40R.elm2;
goto _16;
_14:
DE28RS(M,IORDER,RF,DF,DELTY);
for I:=1 to M do
 begin
  DYP[I-1] := DY[I-1];
  DY[I-1] := YX[I-1]-YP[I-1];
  DELTY[I-1] := DF[(I-1)+4*M]*C4;
  YX[I-1] := YX[I-1]+DELTY[I-1];
_15:
 end;
_16:
if ( IERR <> 0 ) 
 then UTDE12(IERR,40);
JSTART := 1;
_COM40R.elm1 := H;
end;

end.
